/* moggy C -- first attempt at coding a game using Z88DK + SPLIB2 */
/* zcc +zx -vn moggy.c -lsplib2 -lndos -create-app */

/* Include library header : */

#include <stdlib.h>
#include <spritepack.h>

/* Allocate space for the stack */

#pragma output STACKPTR=61440

/* Addresses */

#define AD_TITLE	0xCB20
#define AD_M_TITLE	0xDA58
#define AD_M_GOVER  0xDC41
#define AD_M_NEWLE	0xDDCE
#define AD_FREE		0xDF0F

/* import the clipstruct for the whole screen */
/* TODO: alter this so there's an untouchable line at the top of the 
   screen and another one at the bottom */

extern struct sp_Rect *sp_ClipStruct;
#asm
LIB SPCClipStruct
._sp_ClipStruct         defw SPCClipStruct
#endasm

/* Extern pointers for the graphic definitions: */

	/* moggy: */

	extern uchar moggy0a[];			// Moggy facing the camera
	extern uchar moggy0b[];
	extern uchar moggy1a[];			// Moggy right
	extern uchar moggy1b[];
	extern uchar moggy2a[];			// Moggy up
	extern uchar moggy2b[];
	extern uchar moggy3a[];			// Moggy left
	extern uchar moggy3b[];
	extern uchar moggy4a[];			// Moggy down
	extern uchar moggy4b[];
	extern uchar rano1a[];			// Rano frames:
	extern uchar rano1b[];
	extern uchar rano1c[];
	extern uchar rano2a[];
	extern uchar rano2b[];
	extern uchar rano2c[];
	extern uchar rano3a[];
	extern uchar rano3b[];
	extern uchar rano3c[];
	extern uchar rano4a[];
	extern uchar rano4b[];
	extern uchar rano4c[];

	extern uchar *pantalla;

	/* Other gfx as for different tiles: */

	uchar til_terrain1[] = {0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0};
	uchar til_terrain2[] = {0x0, 0x42, 0x0, 0x10, 0x0, 0x0, 0x2, 0x40};
	uchar til_terrain3[] = {0x0, 0x41, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0};
	uchar til_terrain4[] = {0x1, 0x40, 0x8, 0x44, 0x10, 0x2, 0x8, 0x40};

	uchar til_enemigo[] = {0x3C, 0x7E, 0xDF, 0xBF, 0xDF, 0xAB, 0x56, 0x3C};
	uchar til_amigo[] = {0x3C, 0x5A, 0xBD, 0xFF, 0xC3, 0xBD, 0x7E, 0x3C};
	
	uchar til_borde1[] = {193, 54,205,246,121,174,119,193};
	uchar til_borde2[] = {171, 86,118, 44, 90, 94,187,181};
	uchar til_borde3[] = {219,165, 90,173,181, 90,165,219};
	
	uchar til_seta1[] = {0x7, 0xF, 0x3F, 0x5B, 0xBF, 0x5D, 0xAA, 0x54};
	uchar til_seta2[] = {0xC0, 0xF0, 0x7C, 0xFE, 0xEE, 0x7E, 0xBE, 0x78};
	uchar til_seta3[] = {0x3, 0x7, 0x7, 0x7, 0x3, 0x3, 0x1, 0x0};
	uchar til_seta4[] = {0x0, 0x0, 0x80, 0xC0, 0xE0, 0xE0, 0xE0, 0xC0};
	uchar cl_seta[] = {66, 66, 7, 7};
	
	uchar til_castillo1[] = {0, 0, 24, 52, 56, 116, 122, 116};
	uchar til_castillo2[] = {0, 42, 62, 0, 20, 24, 20, 24};
	uchar til_castillo3[] = {126, 87, 87, 127, 121, 57, 25, 64};
	uchar til_castillo4[] = {20, 248, 244, 88, 244, 232, 82, 0};
	uchar cl_castillo[] = {2, 7, 7, 7};
	
	uchar til_craneo1[] = {0, 3, 69, 14, 1, 0, 17, 15};
	uchar til_craneo2[] = {160, 232, 244, 170, 244, 10, 10, 10};
	uchar til_craneo3[] = {11, 14, 31, 10, 66, 32, 8, 0};
	uchar til_craneo4[] = {180, 232, 192, 128, 12, 30, 4, 0};
	uchar cl_craneo[] = {71, 71, 71, 71};
	
	uchar til_setitas1[] = {32, 0, 124, 247, 223, 123, 62, 15};
	uchar til_setitas2[] = {1, 16, 64, 0, 150, 175, 213, 207};
	uchar til_setitas3[] = {16, 28, 44, 28, 172, 60, 24, 0};
	uchar til_setitas4[] = {0, 12, 4, 142, 22, 14, 4, 32};
	uchar cl_setitas[] = {66, 2, 70, 6};

	uchar til_graves1[] = {0, 4, 64, 0, 3, 12, 31, 27};
	uchar til_graves2[] = {0, 28, 54, 34, 182, 214, 110, 110};
	uchar til_graves3[] = {17, 155, 11, 23, 10, 21, 128, 17};
	uchar til_graves4[] = {110, 96, 106, 96, 100, 64, 20, 0};
	uchar cl_graves[] = {3, 65, 3, 65};

	uchar til_cactus1[] = {64, 160, 65, 160, 65, 160, 81, 43};
	uchar til_cactus2[] = {0, 128, 64, 224, 66, 227, 197, 75};
	uchar til_cactus3[] = {22, 13, 2, 1, 0, 1, 0, 1};
	uchar til_cactus4[] = {214, 252, 216, 224, 192, 192, 192, 160};
	uchar cl_cactus[] = {68, 4, 68, 4};

	uchar til_bloque1[] = {181, 0, 170, 153, 128, 156, 190, 158};
	uchar til_bloque2[] = {255, 5, 237, 109, 237, 1, 81, 173};
	uchar til_bloque3[] = {0, 149, 187, 61, 128, 31, 175, 156};
	uchar til_bloque4[] = {85, 1, 150, 170, 23, 1, 85, 46};
	uchar cl_bloque[] = {67, 3, 67, 3};

	uchar til_anjuel11[] = {0x00, 0x3F, 0x5F, 0x6F, 0x70, 0x77, 0x75, 0x76};
	uchar til_anjuel12[] = {0x00, 0xFC, 0xF8, 0xF2, 0x04, 0xEA, 0x64, 0xEA};
	uchar til_anjuel13[] = {0x75, 0x77, 0x77, 0x70, 0x6A, 0x55, 0x2A, 0x00};
	uchar til_anjuel14[] = {0xE4, 0xEA, 0xE4, 0x0A, 0xA4, 0x52, 0xA8, 0x00};
	uchar cl_anjuel1[] = {0x42, 0x02, 0x02, 0x02};

	uchar til_anjuel21[] = {0x00, 0x7A, 0x40, 0x5C, 0x41, 0x52, 0x45, 0x4A};
	uchar til_anjuel22[] = {0x00, 0xFE, 0x02, 0x72, 0x42, 0x88, 0x52, 0xA8};
	uchar til_anjuel23[] = {0x45, 0x1A, 0x51, 0x52, 0x05, 0x40, 0x7F, 0x00};
	uchar til_anjuel24[] = {0x52, 0xFA, 0x42, 0xCA, 0x52, 0x02, 0x5E, 0x00};
	uchar cl_anjuel2[] = {0x41, 0x01, 0x01, 0x01};

	uchar til_anjuel31[] = {0x00, 0x7F, 0x7E, 0x55, 0x00, 0x77, 0x67, 0x55};
	uchar til_anjuel32[] = {0x00, 0x7E, 0x7E, 0x54, 0x00, 0xF6, 0xE6, 0x54};
	uchar til_anjuel33[] = {0x00, 0x7F, 0x7E, 0x55, 0x00, 0x77, 0x67, 0x00};
	uchar til_anjuel34[] = {0x00, 0x7E, 0x7E, 0x54, 0x00, 0xF6, 0xE6, 0x00};
	uchar cl_anjuel3[] = {0x46, 0x46, 0x06, 0x06};

	uchar til_anjuel41[] = {0x00, 0x3F, 0x5D, 0x6F, 0x77, 0x7B, 0x5D, 0x5E};
	uchar til_anjuel42[] = {0x00, 0xFC, 0x38, 0xF2, 0xE4, 0xCA, 0x94, 0x2A};
	uchar til_anjuel43[] = {0x7E, 0x5D, 0x7A, 0x75, 0x6A, 0x55, 0x2A, 0x00};
	uchar til_anjuel44[] = {0x54, 0x2A, 0x94, 0x4A, 0xA4, 0x52, 0xA8, 0x00};
	uchar cl_anjuel4[] = {0x45, 0x05, 0x05, 0x05};

	uchar til_beiker11[] = {31, 32, 68, 134, 143, 159, 70, 70};
	uchar til_beiker12[] = {232, 84, 42, 20, 154, 20, 40, 52};
	uchar til_beiker13[] = {70, 34, 32, 32, 16, 16, 16, 15};
	uchar til_beiker14[] = {40, 80, 104, 80, 160, 208, 160, 192};
	uchar cl_beiker1[] = {6, 6, 6, 6};

	uchar til_beiker21[] = {56, 84, 43, 23, 42, 84, 108, 56};
	uchar til_beiker22[] = {81, 42, 29, 198, 50, 10, 106, 154};
	uchar til_beiker23[] = {7, 123, 213, 171, 117, 11, 10, 12};
	uchar til_beiker24[] = {127, 65, 125, 123, 58, 58, 50, 28};
	uchar cl_beiker2[] = {2, 4, 6, 7};

	uchar til_beiker31[] = {8, 7, 8, 32, 181, 83, 165, 230};
	uchar til_beiker32[] = {112, 216, 252, 6, 67, 169, 84, 42};
	uchar til_beiker33[] = {231, 66, 102, 60, 24, 25, 63, 125};
	uchar til_beiker34[] = {126, 60, 122, 114, 60, 0, 252, 0};
	uchar cl_beiker3[] = {2, 4, 6, 7};

	uchar til_fondo1[] = {70, 79, 39, 26, 120, 148, 147, 96};
	uchar til_fondo2[] = {126, 82, 74, 166, 146, 146, 98, 7};
	uchar til_fondo3[] = {224, 195, 173, 17, 42, 36, 74, 113};
	uchar til_fondo4[] = {8, 12, 18, 60, 66, 126, 129, 255};
	uchar til_fondo5[] = {63, 83, 149, 249, 159, 169, 202, 252};
	uchar til_fondo6[] = {128, 192, 254, 221, 220, 124, 34, 17};
	uchar til_fondo7[] = {129, 127, 113, 255, 168, 88, 160, 64};
	uchar til_fondo8[] = {7, 3, 21, 8, 84, 32, 208, 64};

	/* Atari FONT */

	uchar font_atari_33[] = {0xE, 0xE, 0x1C, 0x18, 0x10, 0x0, 0x20, 0x0};
	uchar font_atari_34[] = {0x6E, 0x6E, 0x26, 0x48, 0x0, 0x0, 0x0, 0x0};
	uchar font_atari_35[] = {0x6C, 0x6C, 0xFE, 0x6C, 0xFE, 0x6C, 0x6C, 0x0};
	uchar font_atari_36[] = {0x18, 0x3E, 0x60, 0x3C, 0x6, 0x7C, 0x18, 0x0};
	uchar font_atari_37[] = {0x0, 0xC6, 0xCC, 0x18, 0x30, 0x66, 0xC6, 0x0};
	uchar font_atari_38[] = {0x38, 0x6C, 0x38, 0x76, 0xDC, 0xCC, 0x76, 0x0};
	uchar font_atari_39[] = {0x18, 0x18, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0};
	uchar font_atari_40[] = {0xC, 0x18, 0x30, 0x30, 0x30, 0x18, 0xC, 0x0};
	uchar font_atari_41[] = {0x30, 0x18, 0xC, 0xC, 0xC, 0x18, 0x30, 0x0};
	uchar font_atari_42[] = {0x0, 0x66, 0x3C, 0xFF, 0x3C, 0x66, 0x0, 0x0};
	uchar font_atari_43[] = {0x0, 0x18, 0x18, 0x7E, 0x18, 0x18, 0x0, 0x0};
	uchar font_atari_44[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x18, 0x30};
	uchar font_atari_45[] = {0x0, 0x0, 0x0, 0x7E, 0x0, 0x0, 0x0, 0x0};
	uchar font_atari_46[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x18, 0x0};
	uchar font_atari_47[] = {0x6, 0xC, 0x18, 0x30, 0x60, 0xC0, 0x80, 0x0};
	uchar font_atari_48[] = {0x38, 0x4C, 0xC6, 0xC6, 0xC6, 0x64, 0x38, 0x0};
	uchar font_atari_49[] = {0x18, 0x38, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x0};
	uchar font_atari_50[] = {0x7C, 0xC6, 0xE, 0x3C, 0x78, 0xE0, 0xFE, 0x0};
	uchar font_atari_51[] = {0x7E, 0xC, 0x18, 0x3C, 0x6, 0xC6, 0x7C, 0x0};
	uchar font_atari_52[] = {0x1C, 0x3C, 0x6C, 0xCC, 0xFE, 0xC, 0xC, 0x0};
	uchar font_atari_53[] = {0xFC, 0xC0, 0xFC, 0x6, 0x6, 0xC6, 0x7C, 0x0};
	uchar font_atari_54[] = {0x3C, 0x60, 0xC0, 0xFC, 0xC6, 0xC6, 0x7C, 0x0};
	uchar font_atari_55[] = {0xFE, 0xC6, 0xC, 0x18, 0x30, 0x30, 0x30, 0x0};
	uchar font_atari_56[] = {0x78, 0xC4, 0xE4, 0x78, 0x9E, 0x86, 0x7C, 0x0};
	uchar font_atari_57[] = {0x7C, 0xC6, 0xC6, 0x7E, 0x6, 0xC, 0x78, 0x0};
	uchar font_atari_58[] = {0x0, 0x18, 0x18, 0x0, 0x0, 0x18, 0x18, 0x0};
	uchar font_atari_59[] = {0x0, 0x18, 0x18, 0x0, 0x0, 0x18, 0x18, 0x30};
	uchar font_atari_60[] = {0x6, 0xC, 0x18, 0x30, 0x18, 0xC, 0x6, 0x0};
	uchar font_atari_61[] = {0x0, 0x0, 0x7E, 0x0, 0x0, 0x7E, 0x0, 0x0};
	uchar font_atari_62[] = {0x60, 0x30, 0x18, 0xC, 0x18, 0x30, 0x60, 0x0};
	uchar font_atari_63[] = {0x7C, 0xC6, 0xC, 0x18, 0x18, 0x0, 0x18, 0x0};
	uchar font_atari_64[] = {0x7C, 0xC6, 0xDE, 0xDE, 0xDE, 0xC0, 0x78, 0x0};
	uchar font_atari_65[] = {0x38, 0x6C, 0xC6, 0xC6, 0xFE, 0xC6, 0xC6, 0x0};
	uchar font_atari_66[] = {0xFC, 0xC6, 0xC6, 0xFC, 0xC6, 0xC6, 0xFC, 0x0};
	uchar font_atari_67[] = {0x3C, 0x66, 0xC0, 0xC0, 0xC0, 0x66, 0x3C, 0x0};
	uchar font_atari_68[] = {0xF8, 0xCC, 0xC6, 0xC6, 0xC6, 0xCC, 0xF8, 0x0};
	uchar font_atari_69[] = {0x7E, 0x60, 0x60, 0x7C, 0x60, 0x60, 0x7E, 0x0};
	uchar font_atari_70[] = {0xFE, 0xC0, 0xC0, 0xFC, 0xC0, 0xC0, 0xC0, 0x0};
	uchar font_atari_71[] = {0x3E, 0x60, 0xC0, 0xCE, 0xC6, 0x66, 0x3E, 0x0};
	uchar font_atari_72[] = {0xC6, 0xC6, 0xC6, 0xFE, 0xC6, 0xC6, 0xC6, 0x0};
	uchar font_atari_73[] = {0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x0};
	uchar font_atari_74[] = {0x6, 0x6, 0x6, 0x6, 0x6, 0xC6, 0x7C, 0x0};
	uchar font_atari_75[] = {0xC6, 0xCC, 0xD8, 0xF0, 0xF8, 0xDC, 0xCE, 0x0};
	uchar font_atari_76[] = {0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x7E, 0x0};
	uchar font_atari_77[] = {0xC6, 0xEE, 0xFE, 0xFE, 0xD6, 0xC6, 0xC6, 0x0};
	uchar font_atari_78[] = {0xC6, 0xE6, 0xF6, 0xFE, 0xDE, 0xCE, 0xC6, 0x0};
	uchar font_atari_79[] = {0x7C, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0x7C, 0x0};
	uchar font_atari_80[] = {0xFC, 0xC6, 0xC6, 0xC6, 0xFC, 0xC0, 0xC0, 0x0};
	uchar font_atari_81[] = {0x7C, 0xC6, 0xC6, 0xC6, 0xDE, 0xCC, 0x7A, 0x0};
	uchar font_atari_82[] = {0xFC, 0xC6, 0xC6, 0xCE, 0xF8, 0xDC, 0xCE, 0x0};
	uchar font_atari_83[] = {0x78, 0xCC, 0xC0, 0x7C, 0x6, 0xC6, 0x7C, 0x0};
	uchar font_atari_84[] = {0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x0};
	uchar font_atari_85[] = {0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0x7C, 0x0};
	uchar font_atari_86[] = {0xC6, 0xC6, 0xC6, 0xEE, 0x7C, 0x38, 0x10, 0x0};
	uchar font_atari_87[] = {0xC6, 0xC6, 0xD6, 0xFE, 0xFE, 0xEE, 0xC6, 0x0};
	uchar font_atari_88[] = {0xC6, 0xEE, 0x7C, 0x38, 0x7C, 0xEE, 0xC6, 0x0};
	uchar font_atari_89[] = {0x66, 0x66, 0x66, 0x3C, 0x18, 0x18, 0x18, 0x0};
	uchar font_atari_90[] = {0xFE, 0xE, 0x1C, 0x38, 0x70, 0xE0, 0xFE, 0x0};
	uchar font_atari_91[] = {0x3C, 0x30, 0x30, 0x30, 0x30, 0x30, 0x3C, 0x0};
	uchar font_atari_92[] = {0xC0, 0x60, 0x30, 0x18, 0xC, 0x6, 0x2, 0x0};
	uchar font_atari_93[] = {0x3C, 0xC, 0xC, 0xC, 0xC, 0xC, 0x3C, 0x0};
	uchar font_atari_94[] = {0x10, 0x38, 0x6C, 0xC6, 0x0, 0x0, 0x0, 0x0};
	uchar font_atari_95[] = {0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xFF};
	uchar font_atari_96[] = {0x30, 0x18, 0xC, 0x0, 0x0, 0x0, 0x0, 0x0};

/* Rano animation */

extern int offsets[];
#asm
._offsets
	defw _rano2a-_rano1a
	defw _rano3a-_rano2a
	defw _rano4a-_rano3a
	defw _rano3a-_rano4a
	defw _rano2a-_rano3a
	defw _rano1a-_rano2a
#endasm

/* Sprite definitions: */

#asm

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy0a
defb @00111100, @10000001
defb @01111110, @00000000
defb @11011011, @00000000
defb @11011011, @00000000
defb @11111111, @00000000
defb @11011011, @00000000
defb @01100110, @00000000
defb @00111100, @10000001

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy0b
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy1a
defb @00111100, @10000001
defb @01111010, @00000000
defb @11111011, @00000000
defb @10111111, @00000000
defb @11000000, @00000000
defb @11100011, @00000000
defb @01111110, @00000000
defb @00111100, @10000001

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy1b
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy2a
defb @00110100, @10000001
defb @01110110, @00000000
defb @10010011, @00000000
defb @11110011, @00000000
defb @11110011, @00000000
defb @11110111, @00000000
defb @01101110, @00000000
defb @00111100, @10000001

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy2b
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy3a
defb @00111100, @10000001
defb @01111110, @00000000
defb @11000111, @00000000
defb @00000011, @00000000
defb @11111101, @00000000
defb @11011111, @00000000
defb @01011110, @00000000
defb @00111100, @10000001

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy3b
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy4a
defb @00111100, @10000001
defb @01110110, @00000000
defb @11101111, @00000000
defb @11001111, @00000000
defb @11001111, @00000000
defb @11001001, @00000000
defb @01101110, @00000000
defb @00101100, @10000001

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._moggy4b
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano1a
defb @01000110, @00010000
defb @01001100, @00000000
defb @01100011, @00000000
defb @00110111, @10000000
defb @00011111, @11000000
defb @00001100, @11100000
defb @00001011, @11100000
defb @00001111, @11100000

defb @00001011, @11100000
defb @00000101, @11100000
defb @00011010, @11000000
defb @00110000, @10000000
defb @00110000, @10000111
defb @00000000, @11001111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano1b
defb @01100000, @00001111
defb @00110000, @00000111
defb @11000000, @00000001
defb @11100110, @00000000
defb @11111100, @00000001
defb @00110000, @00000011
defb @11010000, @00000111
defb @11110000, @00000111

defb @11110000, @00000111
defb @01110000, @00000111
defb @11011000, @00000011
defb @00001000, @00000011
defb @00001100, @11100001
defb @00000100, @11100001
defb @00001100, @11100001
defb @00000100, @11110001

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano1c
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano2a
defb @00000110, @11110000
defb @10001100, @10100000
defb @01000011, @00000000
defb @01110111, @00000000
defb @00111111, @10000000
defb @00001100, @11000000
defb @00001011, @11100000
defb @00001111, @11100000

defb @00001011, @11100000
defb @00000101, @11100000
defb @00011010, @11000000
defb @00011000, @11000000
defb @00110000, @10000111
defb @00110000, @10000111
defb @00000000, @11001111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano2b
defb @01100000, @00001111
defb @00110000, @00000011
defb @11000100, @00000001
defb @11101100, @00000001
defb @11111000, @00000011
defb @00110000, @00000111
defb @11010000, @00000111
defb @11110000, @00000111

defb @11110000, @00000111
defb @01110000, @00000111
defb @11011000, @00000011
defb @00000100, @00000001
defb @00001010, @11100000
defb @00000110, @11110000
defb @00000010, @11111000
defb @00000000, @11111101

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano2c
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano3a
defb @00000110, @11110000
defb @00001100, @11100000
defb @00000011, @11110000
defb @11100111, @10000000
defb @01111111, @00000000
defb @00001100, @10000000
defb @00001011, @11100000
defb @00001111, @11100000

defb @00001011, @11100000
defb @00000101, @11110000
defb @00001010, @11100000
defb @00011000, @11000000
defb @00011000, @11000011
defb @00011000, @11000011
defb @00011000, @11000011
defb @00000000, @11100111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano3b
defb @01100000, @00001111
defb @00110000, @00000111
defb @11001000, @00000011
defb @11101000, @00000011
defb @11111000, @00000011
defb @00110000, @00000111
defb @11010000, @00000111
defb @11110000, @00000111

defb @11110000, @00000111
defb @01110000, @00000111
defb @11011000, @00000001
defb @00001110, @00000000
defb @00000110, @11110000
defb @00000000, @11111001
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano3c
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano4a
defb @00000110, @10110000
defb @01001100, @00000000
defb @01100011, @00000000
defb @00110111, @10000000
defb @00011111, @11000000
defb @00001100, @11100000
defb @00001011, @11100000
defb @00001111, @11100000

defb @00001011, @11100000
defb @00001101, @11100000
defb @00011010, @11000000
defb @00011000, @11000000
defb @00001000, @11000011
defb @00011000, @11000011
defb @00000000, @11100111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano4b
defb @01100000, @00001111
defb @00110000, @00000111
defb @11000000, @00000011
defb @11101100, @00000001
defb @11111000, @00000011
defb @00110000, @00000111
defb @11010000, @00000111
defb @11110000, @00000111

defb @11110000, @00000111
defb @01110000, @00000111
defb @11011000, @00000011
defb @00010100, @00000001
defb @00001100, @11100001
defb @00001100, @11100001
defb @00000000, @11110011
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

._rano4c

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111
defb @00000000, @11111111

#endasm

/* Manage keys and joystick at the same time: */

struct sp_UDK keys;

/* Create memory allocator for sprite routines */

void *my_malloc(uint bytes)
{
   return sp_BlockAlloc(0);
}

void *u_malloc = my_malloc;
void *u_free = sp_FreeBlock;

/* Strings printed during the game */

struct sp_PSS ps;         /* a print string struct used by sp_PrintString */
uchar status[] = "\x16\x00\x00\x11\x01\x10\x04e\x10\x07 LIFE:00\x16\x00\x14\x10\x03f\x10\x07 FRIENDS:00\x16\x17\x0e00:00";
uchar msg_level[] = "\x16\x0d\x0c\x10\x04\x11\x0LEVEL 00\x16\x0e\x0bRESCUE 00!\x16\x0f\x0d00:00M";
uchar msg_gameover[] = "\x16\xb\x7\x10\x1\x11\x7 G A M E  O V E R ";
uchar msg_timeover[] = "\x16\xb\x7\x10\x1\x11\x7 T I M E  O V E R ";
uchar msg_menu[] = "\x16\x0c\x07\x10\x04\x11\x001 KEYBOARD O P Q A\x16\x0e\x072 KEYBOARD W A S D\x16\x10\x073 INTERFACE II\x16\x15\x0b\x10\x06C-CREDITS!\x16\x17\x08\x10\x05CEZ GAMES STUDIO\x16\x16\x0c(C) 2005";
uchar msg_final[] = "\x10\x04\x11\x00\x16\x05\x08  YOU MADE IT!  \x16\x07\x0bYOU SAVED\x16\x08\x09YOUR FRIENDS\x16\x10\x09NOS VEREMOS EN\x16\x11\x07PROXIMAS AVENTURAS";
uchar msg_theend[] = "\x10\x03\x11\x00\x16\x0a\x04fff f f ff    ff ff  ff\x16\x0b\x05f  f f f     f  f f f f\x16\x0c\x05f  fff ff ff ff f f f f\x16\x0d\x05f  f f f     f  f f f f\x16\x0e\x05f  f f ff    ff f f ff";
uchar msg_credits[] = "\x10\x06\x16\x06\x0cC R E W\x10\x04\x16\x08\x0aBYTES:\x16\x0b\x0aGFX:\x16\x10\x0aSFX:\x10\x07\x16\x09\x0dNA_TH_AN\x16\x0d\x0fBEYKER\x16\x0e\x0fANJUEL\x16\x0c\x0dNA_TH_AN\x16\x11\x0fBEYKER";
uchar msg_hurryup[] = "\x10\x02\x11\x07\x12\x01\x16\x0c\x0b HURRY UP!! \x12\x00";

/* Some structs & globals */

typedef struct
{
	int x;			// In FIX, i.e. realvalue = x >> 7
	int y;
	int mx;			// From 0 to 512 (0 to 4 in FIX)
	int my;
	uchar facing;	// Direction: 0 to 4
	uchar prev_facing;
} MOGGYTYPE;

typedef struct
{
	uchar x;
	uchar y;
	uchar mx;
	uchar my;
	uchar frame;
	uchar ct;
	uint c;
} RANOTYPE;

typedef struct
{
	uchar x;
	uchar y;
} OBJPLACEMENT;

typedef struct
{
	uchar num_amigos;
	uchar num_enemigos;
	uchar num_setas;
	uchar actrano;
	uchar loch;
	uchar total_time;
} LEVELDATATYPE;

LEVELDATATYPE level_data[25] = {	
	{5, 10, 5, 0, 0},
	{6, 11, 5, 0, 0},
	{7, 12, 6, 0, 0},
	{8, 12, 5, 1, 0},
	{8, 16, 5, 0, 0},
	{10, 20, 5, 0, 0},
	{10, 22, 6, 1, 0},
	{10, 25, 7, 0, 0},
	{11, 25, 7, 0, 0},
	{12, 25, 7, 0, 0},
	{12, 30, 7, 0, 0},
	{12, 25, 5, 1, 0},
	{14, 25, 5, 1, 0},
	{15, 25, 6, 1, 0},
	{15, 25, 7, 1, 0},
	{15, 25, 10, 1, 0},
	{15, 30, 6, 1, 0},
	{16, 30, 7, 1, 0},
	{17, 30, 9, 1, 0},
	{18, 32, 9, 1, 0},
	{20, 35, 10, 0, 0},
	{22, 35, 11, 0, 0},
	{25, 35, 12, 0, 0},
	{27, 37, 13, 0, 0},
	{30, 40, 14, 1, 0}
};

/* Initial State of Print String Struct */ 

/* Some handy routines */

/* Function taken from the Complete Spectrum ROM Disassembly */
/* Modified to remove the di, ei and border interactions */
void BEEP (unsigned int cycles, unsigned int tone)
{
#asm
		pop bc					; bc = return address
		pop hl					; hl = tone
		pop de					; de = cycles
		push de
		push hl
		push bc
l03b5:  
        ld      a,l             ;
        srl     l               ;
        srl     l               ; l = medium part of tone period
        cpl                     ;
        and     0x03            ; a = 3 - fine part of tone period
        ld      c,a             ;
        ld      b,0x00          ;
        ld      ix,l03d1        ; address: be-ix+3
        add     ix,bc           ;   ix holds address of entry into the loop
                                ;   the loop will contain 0-3 nops, implementing
                                ;   the fine part of the tone period.
        ld      a,(0x5c48)      ; bordcr
        and     0x38            ; bits 5..3 contain border colour
        rrca                    ; border colour bits moved to 2..0
        rrca                    ;   to match border bits on port #fe
        rrca                    ;
        or       0x08           ; bit 3 set (tape output bit on port #fe)
                                ;   for loud sound output
l03d1:  nop						; optionally executed nops for small
l03d2:  nop						;
l03d3:  nop						;
l03d4:  inc     b				;
        inc     c				;
l03d6:  dec     c				; timing loop for duration of
        jr      nz,l03d6		;   high or low pulse of waveform
        ld      c,0x3f			;
        dec     b				;
        jp      nz,l03d6		; to be-h&l-lp
        xor     0x10			; toggle output beep bit
        out     (0xfe),a		; output pulse
        ld      b,h				; b = coarse part of tone period
        ld      c,a				; save port #fe output byte
        bit     4,a				; if new output bit is high, go
        jr      nz,l03f2		;   to be-again
        ld      a,d				; one cycle of waveform has completed
        or      e				;   (low->low). if cycle countdown = 0
        jr      z,l03f6			;   go to be-end
        ld      a,c				; restore output byte for port #fe
        ld      c,l				; c = medium part of tone period
        dec     de				; decrement cycle count
        jp      (ix)			; do another cycle
l03f2:  ld      c,l				; c = medium part of tone period
        inc     c				; adds 16 cycles to make duration of high = duration of low
        jp      (ix)			; do high pulse of tone
l03f6:  
#endasm
}

unsigned char my_tmp_border;

/* Border routine by Santiago Romero */
void BORDER( unsigned char value )
{
	my_tmp_border = value << 3;

#asm
	ld hl, 2
	add hl, sp
	ld a, (hl)
	ld c, 254
	out (c), a
	ld hl, 23624
	ld a, (_my_tmp_border)
	ld (hl), a
#endasm
}

void portada()
{
#asm
	call AD_TITLE
#endasm
}

void box (uchar x1, uchar y1, uchar x2, uchar y2)
{
	uchar y, x;

	sp_PrintAtInv (y1, x1, INK_YELLOW | PAPER_RED, 'u');
	sp_PrintAtInv (y1, x2, INK_YELLOW | PAPER_RED, 'u');
	sp_PrintAtInv (y2, x1, INK_YELLOW | PAPER_RED, 'u');
	sp_PrintAtInv (y2, x2, INK_YELLOW | PAPER_RED, 'u');

	for (x = x1 + 1; x < x2; x++)
	{
		sp_PrintAtInv (y1, x, INK_YELLOW | PAPER_RED, 's');
		sp_PrintAtInv (y2, x, INK_YELLOW | PAPER_RED, 's');
	}

	for (y = y1 + 1; y < y2; y++)
	{
		sp_PrintAtInv (y, x1, INK_YELLOW | PAPER_RED, 't');
		sp_PrintAtInv (y, x2, INK_YELLOW | PAPER_RED, 't');

		for (x = x1 + 1; x < x2; x++)
			sp_PrintAtInv (y, x, INK_WHITE | PAPER_BLACK, ' ');
	}
}

/* Main program */

uchar *info = "      ";

struct sp_Rect spritesClipValues;
struct sp_Rect *spritesClip;

main ()
{

	/* Local variable definitions */
	
	MOGGYTYPE moggy;
	RANOTYPE rano;

	uchar playfield[704];	// 32 * 22 tiles playfield

	struct sp_SS *sp_moggy0;
	struct sp_SS *sp_moggy1;
	struct sp_SS *sp_moggy2;
	struct sp_SS *sp_moggy3;
	struct sp_SS *sp_moggy4;
	struct sp_SS *sp_rano;

	uint reset;
	char i, j;
	uint value;
	uint pixelx, pixely, tilex, tiley, offsetx, offsety;
	uint x, y, r;
	uint num_amigos;
	uint num_enemigos;
	uint num_setas;
	uint actrano;
	uint found;
	uchar difficulty;
	char en, am;
	uchar flag1 = 0;
	uchar flag2 = 0;
	uchar level;
	uint score;
	uint key_1;
	uint key_2;
	uint key_3;
	uint key_c;
	uint key_cheat;
	uint key_enter;
	uint key_space;
	int time_left;
	uint counter_time;
	uint level_colour;

	/* For level gfx */

	uchar *t1_1, *t1_2, *t1_3, *t1_4;
	uchar *t2_1, *t2_2, *t2_3, *t2_4;
	uchar *tf_1, *tf_2;
	uchar *cl1, *cl2;

	/* Substitute BASICs ISR for this thingo: */

	#asm
		di
	#endasm
	
	sp_InitIM2(0xf1f1);				// Does nothing :)
	sp_CreateGenericISR(0xf1f1); 
	
	#asm 
		ei 
	#endasm 

	/* Initialization stuff */
	
	sp_Initialize (INK_YELLOW | PAPER_BLUE, ' ');
	sp_Border (BLUE);
	sp_AddMemory(0, 100, 14, AD_FREE);		// Allocate for 100 blocks of memory @ 0xdf0f. Move?
	ps.flags  = sp_PSS_INVALIDATE;
    ps.bounds = sp_ClipStruct;
	BORDER (1);
	
	difficulty = 8;					// Set in menu

	spritesClipValues.row_coord = 1;
	spritesClipValues.col_coord = 0;
	spritesClipValues.height = 22;
	spritesClipValues.width = 32;
	spritesClip = &spritesClipValues;

	/* Create sprites */

	sp_moggy0 = sp_CreateSpr(sp_MASK_SPRITE, 2, moggy0a, 1, INK_YELLOW | BRIGHT);
	sp_AddColSpr(sp_moggy0, moggy0b, INK_YELLOW | BRIGHT);

	sp_moggy1 = sp_CreateSpr(sp_MASK_SPRITE, 2, moggy1a, 1, INK_YELLOW | BRIGHT);
	sp_AddColSpr(sp_moggy1, moggy1b, INK_YELLOW | BRIGHT);

	sp_moggy2 = sp_CreateSpr(sp_MASK_SPRITE, 2, moggy2a, 1, INK_YELLOW | BRIGHT);
	sp_AddColSpr(sp_moggy2, moggy2b, INK_YELLOW | BRIGHT);

	sp_moggy3 = sp_CreateSpr(sp_MASK_SPRITE, 2, moggy3a, 1, INK_YELLOW | BRIGHT);
	sp_AddColSpr(sp_moggy3, moggy3b, INK_YELLOW | BRIGHT);

	sp_moggy4 = sp_CreateSpr(sp_MASK_SPRITE, 2, moggy4a, 1, INK_YELLOW | BRIGHT);
	sp_AddColSpr(sp_moggy4, moggy4b, INK_YELLOW | BRIGHT);

	sp_rano = sp_CreateSpr(sp_OR_SPRITE, 3, rano1a, 2, PAPER_BLACK | INK_GREEN | BRIGHT);
	sp_AddColSpr(sp_rano, rano1b, PAPER_BLACK | INK_GREEN | BRIGHT);
	sp_AddColSpr(sp_rano, rano1c, PAPER_BLACK | INK_GREEN | BRIGHT);

	/* Create tiles */

	sp_TileArray('a', til_terrain1);
	sp_TileArray('b', til_terrain2);
	sp_TileArray('c', til_terrain3);
	sp_TileArray('d', til_terrain4);
	sp_TileArray('e', til_enemigo);
	sp_TileArray('f', til_amigo);
	sp_TileArray('s', til_borde1);
	sp_TileArray('t', til_borde2);
	sp_TileArray('u', til_borde3);

	/* Atari font */

	sp_TileArray ('!', font_atari_33);
	sp_TileArray ('"', font_atari_34);
	sp_TileArray ('#', font_atari_35);
	sp_TileArray ('$', font_atari_36);
	sp_TileArray ('%', font_atari_37);
	sp_TileArray ('&', font_atari_38);
	sp_TileArray ('\'', font_atari_39);
	sp_TileArray ('(', font_atari_40);
	sp_TileArray (')', font_atari_41);
	sp_TileArray ('*', font_atari_42);
	sp_TileArray ('+', font_atari_43);
	sp_TileArray (',', font_atari_44);
	sp_TileArray ('-', font_atari_45);
	sp_TileArray ('.', font_atari_46);
	sp_TileArray ('/', font_atari_47);
	sp_TileArray ('0', font_atari_48);
	sp_TileArray ('1', font_atari_49);
	sp_TileArray ('2', font_atari_50);
	sp_TileArray ('3', font_atari_51);
	sp_TileArray ('4', font_atari_52);
	sp_TileArray ('5', font_atari_53);
	sp_TileArray ('6', font_atari_54);
	sp_TileArray ('7', font_atari_55);
	sp_TileArray ('8', font_atari_56);
	sp_TileArray ('9', font_atari_57);
	sp_TileArray (':', font_atari_58);
	sp_TileArray (';', font_atari_59);
	sp_TileArray ('<', font_atari_60);
	sp_TileArray ('=', font_atari_61);
	sp_TileArray ('>', font_atari_62);
	sp_TileArray ('?', font_atari_63);
	sp_TileArray ('@', font_atari_64);
	sp_TileArray ('A', font_atari_65);
	sp_TileArray ('B', font_atari_66);
	sp_TileArray ('C', font_atari_67);
	sp_TileArray ('D', font_atari_68);
	sp_TileArray ('E', font_atari_69);
	sp_TileArray ('F', font_atari_70);
	sp_TileArray ('G', font_atari_71);
	sp_TileArray ('H', font_atari_72);
	sp_TileArray ('I', font_atari_73);
	sp_TileArray ('J', font_atari_74);
	sp_TileArray ('K', font_atari_75);
	sp_TileArray ('L', font_atari_76);
	sp_TileArray ('M', font_atari_77);
	sp_TileArray ('N', font_atari_78);
	sp_TileArray ('O', font_atari_79);
	sp_TileArray ('P', font_atari_80);
	sp_TileArray ('Q', font_atari_81);
	sp_TileArray ('R', font_atari_82);
	sp_TileArray ('S', font_atari_83);
	sp_TileArray ('T', font_atari_84);
	sp_TileArray ('U', font_atari_85);
	sp_TileArray ('V', font_atari_86);
	sp_TileArray ('W', font_atari_87);
	sp_TileArray ('X', font_atari_88);
	sp_TileArray ('Y', font_atari_89);
	sp_TileArray ('Z', font_atari_90);
	sp_TileArray ('[', font_atari_91);
	sp_TileArray ('\\', font_atari_92);
	sp_TileArray (']', font_atari_93);
	sp_TileArray ('^', font_atari_94);
	sp_TileArray ('_', font_atari_95);
	sp_TileArray ('`', font_atari_96);

	sp_ClearRect(sp_ClipStruct, INK_GREEN | PAPER_BLACK | BRIGHT, ' ', sp_CR_TILES); 
	sp_Invalidate(sp_ClipStruct, sp_ClipStruct); 

	rano.frame = 0;
	rano.ct = 0;

	/* Keyboard definition */

	key_1 = sp_LookupKey('1');
	key_2 = sp_LookupKey('2');
	key_3 = sp_LookupKey('3');
	key_c = sp_LookupKey('c');
	key_cheat = sp_LookupKey('4');
	key_enter = sp_LookupKey(13);
	key_space = sp_LookupKey(' ');

	while (1)	
	{

		/* Game has just loaded... */

		/* Play one of Beyker's tunes! */

		#asm
			call AD_M_NEWLE
		#endasm

		quefeo:

		/* MENU HERE */

		sp_ClearRect(sp_ClipStruct, PAPER_BLACK | INK_BLACK, ' ', sp_CR_TILES); 
		sp_Invalidate(sp_ClipStruct, sp_ClipStruct); 
		sp_UpdateNow();

		portada ();
		box (5, 10, 26, 18);
		sp_PrintString(&ps, msg_menu);		
		
		sp_UpdateNow();

		/* Play one of Beyker's tunes! */

		#asm
			call AD_M_TITLE
		#endasm

		while (1)
		{
			if (sp_KeyPressed (key_1))
			{
				keys.up    = sp_LookupKey('q');
				keys.down  = sp_LookupKey('a');
				keys.left  = sp_LookupKey('o');
				keys.right = sp_LookupKey('p');
				keys.fire  = sp_LookupKey(' ');
				reset      = sp_LookupKey('r');
				break;
			} 
			else if (sp_KeyPressed (key_2))
			{
				keys.up    = sp_LookupKey('w');
				keys.down  = sp_LookupKey('s');
				keys.left  = sp_LookupKey('a');
				keys.right = sp_LookupKey('d');
				keys.fire  = sp_LookupKey(' ');
				reset      = sp_LookupKey('r');
				break;
			}
			else if (sp_KeyPressed (key_3))
			{
				keys.up    = sp_LookupKey('9');
				keys.down  = sp_LookupKey('8');
				keys.left  = sp_LookupKey('6');
				keys.right = sp_LookupKey('7');
				keys.fire  = sp_LookupKey('0');
				reset      = sp_LookupKey('r');
				break;
			}
			else if (sp_KeyPressed (key_c))
			{
				portada ();
				box (8, 4, 22, 19);
				sp_PrintString(&ps, msg_credits);		
				sp_UpdateNow();

				/* Play one of Beyker's tunes! */

				#asm
					call AD_M_TITLE
				#endasm

				goto quefeo;			// Qu feo!
			}
		}

		flag1 = 0;
		level = 0;
		en = 20;
		score = 0;
			
		while (!flag1)
		{
			/* Level values */

			num_amigos = level_data[level].num_amigos;
			num_enemigos = level_data[level].num_enemigos;
			num_setas = level_data[level].num_setas;
			actrano = level_data[level].actrano;
			am = 0;

			/* Calculate time left upon level complexity */

			time_left = 2 * num_amigos + num_enemigos;

			flag2 = 0;

			// Pre level code:

			/* Initialize moggy: */

			moggy.x = 0;
			moggy.y = 0;
			moggy.mx = 0;
			moggy.my = 0;
			moggy.facing = 0;
			moggy.prev_facing = 0;

			/* Initialize rano */

			rano.x = 127;
			rano.y = 80;
			rano.mx = ((rand() % 2) << 1) - 1;		// 1 or -1
			rano.my = ((rand() % 2) << 1) - 1;		// 1 or -1

			/* Show intro message */

			sp_ClearRect(sp_ClipStruct, PAPER_BLACK | INK_BLACK, ' ', sp_CR_TILES); 
			sp_Invalidate(sp_ClipStruct, sp_ClipStruct); 
			sp_UpdateNow();

			portada ();
			box (9, 11, 22, 17);
			
			msg_level [13] = '0' + (level + 1) / 10;
			msg_level [14] = '0' + (level + 1) % 10;
			msg_level [25] = '0' + num_amigos / 10;
			msg_level [26] = '0' + num_amigos % 10;
			msg_level [31] = '0' + (time_left / 60) / 10;
			msg_level [32] = '0' + (time_left / 60) % 10;
			msg_level [34] = '0' + (time_left % 60) / 10;
			msg_level [35] = '0' + (time_left % 60) % 10;

			sp_PrintString(&ps, msg_level);
			sp_UpdateNow();
			
			/* Play one of Beyker's tunes! */

			#asm
				call AD_M_NEWLE
			#endasm

			/* Place moggy: */

			sp_MoveSprAbs(sp_moggy0, spritesClip, 0, 1 + moggy.y >> 10, moggy.x >> 10, (moggy.y >> 7) & 7, (moggy.x >> 7) & 7);

			/* Place rano: */

			if (actrano)
				sp_MoveSprAbs(sp_rano, spritesClip, 0, 1 + rano.y>>3, rano.x>>3, rano.x & 7, rano.y & 7);

			/* Switch gfx */

			if (level == 0)
			{
				t1_1 = til_seta1; t1_2 = til_seta2; t1_3 = til_seta3; t1_4 = til_seta4; cl1 = cl_seta;
				t2_1 = til_seta1; t2_2 = til_seta2; t2_3 = til_seta3; t2_4 = til_seta4; cl2 = cl_seta;					
			} 
			else if (level == 1)
			{
				t1_1 = til_seta1; t1_2 = til_seta2; t1_3 = til_seta3; t1_4 = til_seta4; cl1 = cl_seta;
				t2_1 = til_setitas1; t2_2 = til_setitas2; t2_3 = til_setitas3; t2_4 = til_setitas4; cl2 = cl_setitas;
			} 
			else if (level == 2)
			{
				t1_1 = til_setitas1; t1_2 = til_setitas2; t1_3 = til_setitas3; t1_4 = til_setitas4; cl1 = cl_setitas;
				t2_1 = til_setitas1; t2_2 = til_setitas2; t2_3 = til_setitas3; t2_4 = til_setitas4; cl2 = cl_setitas;
			}
			else if (level == 3)
			{
				t1_1 = til_setitas1; t1_2 = til_setitas2; t1_3 = til_setitas3; t1_4 = til_setitas4; cl1 = cl_setitas;
				t2_1 = til_beiker21; t2_2 = til_beiker22; t2_3 = til_beiker23; t2_4 = til_beiker24; cl2 = cl_beiker2;
			}
			else if (level == 4)
			{
				t1_1 = til_beiker21; t1_2 = til_beiker22; t1_3 = til_beiker23; t1_4 = til_beiker24; cl1 = cl_beiker2;
				t2_1 = til_beiker21; t2_2 = til_beiker22; t2_3 = til_beiker23; t2_4 = til_beiker24; cl2 = cl_beiker2;
			}
			else if (level == 5)
			{
				t1_1 = til_beiker21; t1_2 = til_beiker22; t1_3 = til_beiker23; t1_4 = til_beiker24; cl1 = cl_beiker2;
				t2_1 = til_cactus1; t2_2 = til_cactus2; t2_3 = til_cactus3; t2_4 = til_cactus4; cl2 = cl_cactus;
			}
			else if (level == 6)
			{
				t1_1 = til_cactus1; t1_2 = til_cactus2; t1_3 = til_cactus3; t1_4 = til_cactus4; cl1 = cl_cactus;
				t2_1 = til_cactus1; t2_2 = til_cactus2; t2_3 = til_cactus3; t2_4 = til_cactus4; cl2 = cl_cactus;
			}
			else if (level == 7)
			{
				t1_1 = til_cactus1; t1_2 = til_cactus2; t1_3 = til_cactus3; t1_4 = til_cactus4; cl1 = cl_cactus;
				t2_1 = til_beiker31; t2_2 = til_beiker32; t2_3 = til_beiker33; t2_4 = til_beiker34; cl2 = cl_beiker3;
			}
			else if (level == 8)
			{
				t1_1 = til_beiker31; t1_2 = til_beiker32; t1_3 = til_beiker33; t1_4 = til_beiker34; cl1 = cl_beiker3;
				t2_1 = til_beiker31; t2_2 = til_beiker32; t2_3 = til_beiker33; t2_4 = til_beiker34; cl2 = cl_beiker3;
			}
			else if (level == 9)
			{
				t1_1 = til_beiker31; t1_2 = til_beiker32; t1_3 = til_beiker33; t1_4 = til_beiker34; cl1 = cl_beiker3;
				t2_1 = til_castillo1; t2_2 = til_castillo2; t2_3 = til_castillo3; t2_4 = til_castillo4; cl2 = cl_castillo;
			}
			else if (level == 10)
			{
				t1_1 = til_castillo1; t1_2 = til_castillo2; t1_3 = til_castillo3; t1_4 = til_castillo4; cl1 = cl_castillo;
				t2_1 = til_castillo1; t2_2 = til_castillo2; t2_3 = til_castillo3; t2_4 = til_castillo4; cl2 = cl_castillo;
			}
			else if (level == 11)
			{
				t1_1 = til_castillo1; t1_2 = til_castillo2; t1_3 = til_castillo3; t1_4 = til_castillo4; cl1 = cl_castillo;
				t2_1 = til_anjuel11; t2_2 = til_anjuel12; t2_3 = til_anjuel13; t2_4 = til_anjuel14; cl2 = cl_anjuel1;
			}
			else if (level == 12)
			{
				t1_1 = til_anjuel11; t1_2 = til_anjuel12; t1_3 = til_anjuel13; t1_4 = til_anjuel14; cl1 = cl_anjuel1;
				t2_1 = til_anjuel11; t2_2 = til_anjuel12; t2_3 = til_anjuel13; t2_4 = til_anjuel14; cl2 = cl_anjuel1;
			}
			else if (level == 13)
			{
				t1_1 = til_anjuel11; t1_2 = til_anjuel12; t1_3 = til_anjuel13; t1_4 = til_anjuel14; cl1 = cl_anjuel1;
				t2_1 = til_anjuel21; t2_2 = til_anjuel22; t2_3 = til_anjuel23; t2_4 = til_anjuel24; cl2 = cl_anjuel2;
			}
			else if (level == 14)
			{
				t1_1 = til_anjuel21; t1_2 = til_anjuel22; t1_3 = til_anjuel23; t1_4 = til_anjuel24; cl1 = cl_anjuel2;
				t2_1 = til_anjuel21; t2_2 = til_anjuel22; t2_3 = til_anjuel23; t2_4 = til_anjuel24; cl2 = cl_anjuel2;
			}
			else if (level == 15)
			{
				t1_1 = til_anjuel21; t1_2 = til_anjuel22; t1_3 = til_anjuel23; t1_4 = til_anjuel24; cl1 = cl_anjuel2;
				t2_1 = til_anjuel31; t2_2 = til_anjuel32; t2_3 = til_anjuel33; t2_4 = til_anjuel34; cl2 = cl_anjuel3;
			}
			else if (level == 16)
			{
				t1_1 = til_anjuel31; t1_2 = til_anjuel32; t1_3 = til_anjuel33; t1_4 = til_anjuel34; cl1 = cl_anjuel3;
				t2_1 = til_anjuel31; t2_2 = til_anjuel32; t2_3 = til_anjuel33; t2_4 = til_anjuel34; cl2 = cl_anjuel3;
			}
			else if (level == 17)
			{
				t1_1 = til_anjuel31; t1_2 = til_anjuel32; t1_3 = til_anjuel33; t1_4 = til_anjuel34; cl1 = cl_anjuel3;
				t2_1 = til_anjuel41; t2_2 = til_anjuel42; t2_3 = til_anjuel43; t2_4 = til_anjuel44; cl2 = cl_anjuel4;
			}
			else if (level == 18)
			{
				t1_1 = til_anjuel41; t1_2 = til_anjuel42; t1_3 = til_anjuel43; t1_4 = til_anjuel44; cl1 = cl_anjuel4;
				t2_1 = til_anjuel41; t2_2 = til_anjuel42; t2_3 = til_anjuel43; t2_4 = til_anjuel44; cl2 = cl_anjuel4;
			}
			else if (level == 19)
			{
				t1_1 = til_anjuel41; t1_2 = til_anjuel42; t1_3 = til_anjuel43; t1_4 = til_anjuel44; cl1 = cl_anjuel4;
				t2_1 = til_graves1; t2_2 = til_graves2; t2_3 = til_graves3; t2_4 = til_graves4; cl2 = cl_graves;
			}
			else if (level == 20)
			{
				t1_1 = til_graves1; t1_2 = til_graves2; t1_3 = til_graves3; t1_4 = til_graves4; cl1 = cl_graves;
				t2_1 = til_graves1; t2_2 = til_graves2; t2_3 = til_graves3; t2_4 = til_graves4; cl2 = cl_graves;
			}
			else if (level == 21)
			{
				t1_1 = til_graves1; t1_2 = til_graves2; t1_3 = til_graves3; t1_4 = til_graves4; cl1 = cl_graves;
				t2_1 = til_beiker11; t2_2 = til_beiker12; t2_3 = til_beiker13; t2_4 = til_beiker14; cl2 = cl_beiker1;
			}
			else if (level == 22)
			{
				t1_1 = til_beiker11; t1_2 = til_beiker12; t1_3 = til_beiker13; t1_4 = til_beiker14; cl1 = cl_beiker1;
				t2_1 = til_beiker11; t2_2 = til_beiker12; t2_3 = til_beiker13; t2_4 = til_beiker14; cl2 = cl_beiker1;
			}
			else if (level == 23)
			{
				t1_1 = til_beiker11; t1_2 = til_beiker12; t1_3 = til_beiker13; t1_4 = til_beiker14; cl1 = cl_beiker1;
				t2_1 = til_craneo1; t2_2 = til_craneo2; t2_3 = til_craneo3; t2_4 = til_craneo4; cl2 = cl_craneo;
			}
			else if (level == 24)
			{
				t1_1 = til_craneo1; t1_2 = til_craneo2; t1_3 = til_craneo3; t1_4 = til_craneo4; cl1 = cl_craneo;
				t2_1 = til_craneo1; t2_2 = til_craneo2; t2_3 = til_craneo3; t2_4 = til_craneo4; cl2 = cl_craneo;
			}

			sp_TileArray('g', t1_1);
			sp_TileArray('h', t1_2);
			sp_TileArray('i', t1_3);
			sp_TileArray('j', t1_4);
			sp_TileArray('k', t2_1);
			sp_TileArray('l', t2_2);
			sp_TileArray('m', t2_3);
			sp_TileArray('n', t2_4);

			i = rand() & 7;

			switch (i)
			{	
				case 0:
					sp_TileArray('o', til_fondo1);
					break;
				case 1:
					sp_TileArray('o', til_fondo2);
					break;
				case 2:
					sp_TileArray('o', til_fondo3);
					break;
				case 3:
					sp_TileArray('o', til_fondo4);
					break;
				case 4:
					sp_TileArray('o', til_fondo5);
					break;
				case 5:
					sp_TileArray('o', til_fondo6);
					break;
				case 6:
					sp_TileArray('o', til_fondo7);
					break;
				case 7:
					sp_TileArray('o', til_fondo8);
					break;
			}

			i = rand() & 7;

			switch (i)
			{
				case 0:
					sp_TileArray('p', til_fondo1);	
					break;
				case 1:
					sp_TileArray('p', til_fondo2);	
					break;
				case 2:
					sp_TileArray('p', til_fondo3);
					break;
				case 3:
					sp_TileArray('p', til_fondo4);
					break;
				case 4:
					sp_TileArray('p', til_fondo5);
					break;
				case 5:
					sp_TileArray('p', til_fondo6);
					break;
				case 6:
					sp_TileArray('p', til_fondo7);
					break;
				case 7:
					sp_TileArray('p', til_fondo8);
			}

			/* Draw terrain */

			sp_ClearRect(sp_ClipStruct, PAPER_BLUE, ' ', sp_CR_TILES); 

			if (level < 5)
				level_colour = 4;
			else if (level < 10)
				level_colour = 5;
			else if (level < 15)
				level_colour = 3;
			else if (level < 20)
				level_colour = 2;
			else
				level_colour = 1;

			for (value = 0; value < 704; value ++)
				playfield[value] = 0;

			for (y = 1; y < 23; y++)
				for (x=0; x < 32; x++)
				{
					sp_PrintAt(y, x, PAPER_BLACK | level_colour , 'a' + (rand() & 3));	
					
					r = rand () % 100;

					if (r == 0)
						sp_PrintAt(y, x, PAPER_BLACK | level_colour , 'o' + (rand() & 1));	
				}

			/* Draw amigos & enemigos */

			for (i = 0; i < num_enemigos; i ++)
			{
				do
				{
					x = rand() % 32;
					y = rand() % 22;
				} 
				while (x == 0 && y == 0);

				playfield [(y << 5) + x] = 1;

				sp_PrintAt(y + 1, x, PAPER_BLACK | INK_GREEN | BRIGHT, 'e');
			}

			for (i = 0; i < num_setas; i ++)
			{
				x = 1 + rand() % 30;
				y = rand() % 21;
				playfield [(y << 5) + x] = 3;
				playfield [(y << 5) + x + 1] = 3;
				playfield [((y + 1) << 5) + x] = 3;
				playfield [((y + 1) << 5) + x + 1] = 3;

				value = rand() & 1;

				if (value == 0)
				{
					sp_PrintAt(y + 1, x, cl1[0], 'g');
					sp_PrintAt(y + 1, x + 1, cl1[1], 'h');
					sp_PrintAt(y + 2, x, cl1[2], 'i');
					sp_PrintAt(y + 2, x + 1, cl1[3], 'j');
				}
				else
				{
					sp_PrintAt(y + 1, x, cl2[0], 'k');
					sp_PrintAt(y + 1, x + 1, cl2[1], 'l');
					sp_PrintAt(y + 2, x, cl2[2], 'm');
					sp_PrintAt(y + 2, x + 1, cl2[3], 'n');
				}
			}

			for (i = 0; i < num_amigos; i ++)
			{
				do
				{
					x = rand() % 32;
					y = rand() % 22;	
				} 
				while (playfield [(y << 5) + x] != 0 || (x == 0 && y == 0));

				playfield [(y << 5) + x] = 2;

				sp_PrintAt(y + 1, x, PAPER_BLACK | INK_MAGENTA | BRIGHT, 'f');
			}

			/* Calculate time left upon level complexity */


			if (level < 8)
			{
				time_left = 2 * num_amigos + num_enemigos;
			}
			else if (level < 16)
			{
				time_left = 2 * num_amigos + num_enemigos / 2;
			}
			else
			{
				time_left = 2 * num_amigos;
			}

			/* Make tiles visible */

			status [16] = '0' + en / 10;
			status [17] = '0' + en % 10;
			status [35] = '0' + (num_amigos - am) / 10;
			status [36] = '0' + (num_amigos - am) % 10;
			status [40] = '0' + (time_left / 60) / 10;
			status [41] = '0' + (time_left / 60) % 10;
			status [43] = '0' + (time_left % 60) / 10;
			status [44] = '0' + (time_left % 60) % 10;
			sp_PrintString(&ps, status);

			sp_Invalidate(sp_ClipStruct, sp_ClipStruct);
			
			while (!flag2)
			{
				sp_UpdateNow();

				/* Read keyboard / joystick */

				i = sp_JoyKeyboard(&keys);
				moggy.facing = 0;

				if ((i & sp_LEFT) == 0)
				{
					if (moggy.mx > -512)
						moggy.mx -= difficulty;
					moggy.facing = 3;
				}
				else if ((i & sp_RIGHT) == 0)
				{
					if (moggy.mx < 512)
						moggy.mx += difficulty;
					moggy.facing = 1;
				}

				if ((i & sp_UP) == 0)
				{
					if (moggy.my > -512)
						moggy.my -= difficulty;
					moggy.facing = 2;
				}
				else if ((i & sp_DOWN) == 0)
				{
					if (moggy.my < 512)
						moggy.my += difficulty;
					moggy.facing = 4;
				}

				/* Move moggy */
				/* TODO: Change sprite depending on moggy.facing */

				moggy.x += moggy.mx;
				moggy.y += moggy.my;

				if (moggy.x < 0)
				{
					moggy.x = 0;
					moggy.mx = 0;
				}
				else if (moggy.x > 31744)		// This is 248 * 128
				{
					moggy.x = 31744;		
					moggy.mx = 0;
				}

				if (moggy.y < 0)
				{
					moggy.y = 0;
					moggy.my = 0;
				}
				else if (moggy.y > 21504)		// This is 168 * 128
				{
					moggy.y = 21504;
					moggy.my = 0;
				}

				pixelx = moggy.x >> 7;			// UNFIX moggy
				pixely = moggy.y >> 7;

				tilex = pixelx >> 3;			// Tile pos.
				tiley = pixely >> 3;

				offsetx = pixelx & 7;			// offset inside tile.
				offsety = pixely & 7;

				/* Move rano */

				if (actrano)
				{
					rano.x += rano.mx;
					rano.y += rano.my;

					if (rano.x == 0 || rano.x == 240)
						rano.mx = -rano.mx;

					if (rano.y == 0 || rano.y == 159)
						rano.my = -rano.my;
				}

		/*************************************************************************************************/

				/* Check for collisions with background & undo movement if suited */

				if ( abs(moggy.mx) > abs (moggy.my) )
				{
					/* Horizontal */
					if (moggy.mx > 0)
					{
						if (offsety == 0 || tiley == 21)
						{
							if (playfield [(tiley << 5) + tilex + 1] == 3)
							{
								moggy.x = tilex << 10; // * 8 * 127
								if (moggy.mx > difficulty)
									moggy.mx -= difficulty;
								else moggy.mx = 0;
							}
						}
						else
						{
							if (playfield [(tiley << 5) + tilex + 1] == 3 || playfield [32 + (tiley << 5) + tilex + 1] == 3)
							{
								moggy.x = tilex << 10; // * 8 * 127
								if (moggy.mx > difficulty)
									moggy.mx -= difficulty;
								else moggy.mx = 0;
							}
						}
					}
					else if (moggy.mx < 0)
					{
						if (offsety == 0 || tiley == 21)
						{
							if (playfield [(tiley << 5) + tilex] == 3)
							{
								moggy.x = (tilex + 1) << 10;
								if (moggy.mx < -difficulty)
									moggy.mx += difficulty;
								else moggy.mx = 0;
							}
						}
						else
						{
							if (playfield [(tiley << 5) + tilex] == 3 || playfield [32 + (tiley << 5) + tilex] == 3)
							{
								moggy.x = (tilex + 1) << 10;
								if (moggy.mx < -difficulty)
									moggy.mx += difficulty;
							}
						}
					}

					/* Just in case... */

					pixelx = moggy.x >> 7;			// UNFIX moggy
					tilex = pixelx >> 3;			// Tile pos.
					offsetx = pixelx & 7;			// offset inside tile.

					/* Vertical */
					if (moggy.my > 0)
					{
						if (offsetx == 0 || tilex == 31)
						{
							if (playfield [32 + (tiley << 5) + tilex] == 3)
							{
								moggy.y = tiley << 10; // * 8 * 127
								if (moggy.my > difficulty)
									moggy.my -= difficulty;
								else moggy.my = 0;
							}
						}
						else
						{
							if (playfield [32 + (tiley << 5) + tilex] == 3 || playfield [32 + (tiley << 5) + tilex + 1] == 3)
							{
								moggy.y = tiley << 10; // * 8 * 127
								if (moggy.my > difficulty)
									moggy.my -= difficulty;
								else moggy.my = 0;
							}
						}
					}
					else if (moggy.my < 0)
					{
						if (offsetx == 0 || tilex == 31)
						{
							if (playfield [(tiley << 5) + tilex] == 3)
							{
								moggy.y = (tiley + 1) << 10;
								if (moggy.my < -difficulty)
									moggy.my += difficulty;
								else moggy.my = 0;
							}
						}
						else
						{
							if (playfield [(tiley << 5) + tilex] == 3 || playfield [(tiley << 5) + tilex + 1] == 3)
							{
								moggy.y = (tiley + 1) << 10;
								if (moggy.my < -difficulty)
									moggy.my += difficulty;
								else moggy.my = 0;
							}
						}
					}

					/* Just in case... */

					pixely = moggy.y >> 7;
					tiley = pixely >> 3;
					offsety = pixely & 7;
				}
				else
				{
					/* Vertical */
					if (moggy.my > 0)
					{
						if (offsetx == 0 || tilex == 31)
						{
							if (playfield [32 + (tiley << 5) + tilex] == 3)
							{
								moggy.y = tiley << 10; // * 8 * 127
								if (moggy.my > difficulty)
									moggy.my -= difficulty;
								else moggy.my = 0;
							}
						}
						else
						{
							if (playfield [32 + (tiley << 5) + tilex] == 3 || playfield [32 + (tiley << 5) + tilex + 1] == 3)
							{
								moggy.y = tiley << 10; // * 8 * 127
								if (moggy.my > difficulty)
									moggy.my -= difficulty;
								else moggy.my = 0;
							}
						}
					}
					else if (moggy.my < 0)
					{
						if (offsetx == 0 || tilex == 31)
						{
							if (playfield [(tiley << 5) + tilex] == 3)
							{
								moggy.y = (tiley + 1) << 10;
								if (moggy.my < -difficulty)
									moggy.my += difficulty;
								else moggy.my = 0;
							}
						}
						else
						{
							if (playfield [(tiley << 5) + tilex] == 3 || playfield [(tiley << 5) + tilex + 1] == 3)
							{
								moggy.y = (tiley + 1) << 10;
								if (moggy.my < -difficulty)
									moggy.my += difficulty;
								else moggy.my = 0;
							}
						}
					}

					/* Just in case... */

					pixely = moggy.y >> 7;
					tiley = pixely >> 3;
					offsety = pixely & 7;

					/* Horizontal */
					if (moggy.mx > 0)
					{
						if (offsety == 0 || tiley == 21)
						{
							if (playfield [(tiley << 5) + tilex + 1] == 3)
							{
								moggy.x = tilex << 10; // * 8 * 127
								if (moggy.mx > difficulty)
									moggy.mx -= difficulty;
								else moggy.mx = 0;
							}
						}
						else
						{
							if (playfield [(tiley << 5) + tilex + 1] == 3 || playfield [32 + (tiley << 5) + tilex + 1] == 3)
							{
								moggy.x = tilex << 10; // * 8 * 127
								if (moggy.mx > difficulty)
									moggy.mx -= difficulty;
								else moggy.mx = 0;
							}
						}
					}
					else if (moggy.mx < 0)
					{
						if (offsety == 0 || tiley == 21)
						{
							if (playfield [(tiley << 5) + tilex] == 3)
							{
								moggy.x = (tilex + 1) << 10;
								if (moggy.mx < -difficulty)
									moggy.mx += difficulty;
								else moggy.mx = 0;
							}
						}
						else
						{
							if (playfield [(tiley << 5) + tilex] == 3 || playfield [32 + (tiley << 5) + tilex] == 3)
							{
								moggy.x = (tilex + 1) << 10;
								if (moggy.mx < -difficulty)
									moggy.mx += difficulty;
							}
						}
					}

					/* Just in case... */

					pixelx = moggy.x >> 7;			// UNFIX moggy
					tilex = pixelx >> 3;			// Tile pos.
					offsetx = pixelx & 7;			// offset inside tile.

				}

				/* Check for collisions with active objects (amigos / enemigos ) */

				value = (tiley << 5) + tilex;
				found = 0;

				if (playfield [value] == 1)
				{
					en --;
					playfield [value] = 0;
					sp_PrintAtInv(tiley + 1, tilex,  level_colour, 'a' + rand() % 4);	
					found = 1;
					BEEP (50, 0);
				}
				
				if (playfield [value] == 2)
				{
					am ++;
					score ++;
					playfield [value] = 0;
					sp_PrintAtInv(tiley + 1, tilex,  level_colour, 'a' + rand() % 4);	
					found = 1;
					BEEP (50, 20);
				}

				if (offsety != 0 && tiley != 21)
				{
					if (playfield [value + 32] == 1)
					{
						en --;
						playfield [value + 32] = 0;
						sp_PrintAtInv(tiley + 2, tilex,  level_colour, 'a' + rand() % 4);	
						found = 1;
						BEEP (50, 0);
					}
					
					if (playfield [value + 32] == 2)
					{
						am ++;
						score ++;
						playfield [value + 32] = 0;
						sp_PrintAtInv(tiley + 2, tilex,  level_colour, 'a' + rand() % 4);	
						found = 1;
						BEEP (50, 20);
					}
				}

				value ++;

				if (offsetx != 0 && tilex != 31)
				{
					if (playfield [value] == 1)
					{
						en --;
						playfield [value] = 0;
						sp_PrintAtInv(tiley + 1, tilex + 1,  level_colour, 'a' + rand() % 4);	
						found = 1;
						BEEP (50, 0);
					}
					
					if (playfield [value] == 2)
					{
						am ++;
						score ++;
						playfield [value] = 0;
						sp_PrintAtInv(tiley + 1, tilex + 1,  level_colour, 'a' + rand() % 4);	
						found = 1;
						BEEP (50, 20);
					}

					if (offsety != 0 && tiley != 21)
					{
						if (playfield [value + 32] == 1)
						{
							en --;
							playfield [value + 32] = 0;
							sp_PrintAtInv(tiley + 2, tilex + 1,  level_colour, 'a' + rand() % 4);	
							found = 1;
							BEEP (50, 0);
						}
						
						if (playfield [value + 32] == 2)
						{
							am ++;
							score ++;
							playfield [value + 32] = 0;
							sp_PrintAtInv(tiley + 2, tilex + 1,  level_colour, 'a' + rand() % 4);	
							found = 1;
							BEEP (50, 20);
						}
					}
				}

				/* Check for collisions with rano */

				if (actrano)
					if (pixelx >= rano.x - 7 && pixelx <= rano.x + 15 && pixely >= rano.y - 7 && pixely <= rano.y + 15)
					{
						moggy.mx = -moggy.mx;
						moggy.my = -moggy.my;
						rano.mx = -rano.mx;
						rano.my = -rano.my;
						en --;
						found = 1;
						BEEP (50, 0);
						BEEP (2, 2);
						BEEP (5, 4);
					}

		/********************************************************************************************************/

				/* RENDERING */
				
				// Change the sprite trick. I'm sure there's a better way.

				if (moggy.prev_facing != moggy.facing)
				{
					switch (moggy.prev_facing)
					{
						case 0:
							sp_MoveSprAbs(sp_moggy0, spritesClip, 0, 24, 32, 0, 0);
							break;
						case 1:
							sp_MoveSprAbs(sp_moggy1, spritesClip, 0, 24, 32, 0, 0);
							break;
						case 2:
							sp_MoveSprAbs(sp_moggy2, spritesClip, 0, 24, 32, 0, 0);
							break;
						case 3:
							sp_MoveSprAbs(sp_moggy3, spritesClip, 0, 24, 32, 0, 0);
							break;
						case 4:
							sp_MoveSprAbs(sp_moggy4, spritesClip, 0, 24, 32, 0, 0);				
					}
				}

				switch (moggy.facing)
				{
					case 0:
						sp_MoveSprAbs(sp_moggy0, spritesClip, 0, 1 + tiley, tilex, offsetx, offsety);
						break;
					case 1:
						sp_MoveSprAbs(sp_moggy1, spritesClip, 0, 1 + tiley, tilex, offsetx, offsety);
						break;
					case 2:
						sp_MoveSprAbs(sp_moggy2, spritesClip, 0, 1 + tiley, tilex, offsetx, offsety);
						break;
					case 3:
						sp_MoveSprAbs(sp_moggy3, spritesClip, 0, 1 + tiley, tilex, offsetx, offsety);
						break;
					case 4:
						sp_MoveSprAbs(sp_moggy4, spritesClip, 0, 1 + tiley, tilex, offsetx, offsety);
				}

				moggy.prev_facing = moggy.facing;

				/* Render rano */

				if (actrano)
				{
					rano.c = 0;

					rano.ct ++; 
					if (rano.ct == 3) 
					{
						rano.ct = 0;
						rano.c = offsets[rano.frame];
						rano.frame ++;				
						if (rano.frame == 6)
							rano.frame = 0;
					}

					sp_MoveSprAbs(sp_rano, spritesClip, rano.c, 1 + (rano.y >> 3), rano.x >> 3, rano.x & 7, rano.y & 7);
				}

				/* Time machine */

				counter_time = (counter_time + 1) & 63;

				if (counter_time == 0)
				{
					time_left --;

					/* Time over */

					if (time_left <= -1)
					{
						level --;
						flag2 = 1;

						box (5, 9, 26, 13);
						sp_PrintString(&ps, msg_timeover);
						sp_UpdateNow();

						sp_WaitForNoKey ();

						BEEP (50, 0);
						BEEP (50, 2);
						BEEP (50, 4);
						BEEP (50, 0);
						BEEP (50, 2);
						BEEP (50, 4);

						for (x = 0; x < 8 ; x ++)
							for (i=00; i < 50; i++)
							{
								BEEP(10, i);
								BEEP(10, 50-i);
							}

						/* Substract one life */

						en --;

						/* Check if game is over... */

						if (en == 0)
						{
							flag1 = 1;
						}
					}

					/* Hurry up!! */

					if (time_left == 10)
					{
						sp_PrintString(&ps, msg_hurryup);
						sp_UpdateNow();

						for (x = 0; x < 8 ; x ++)
							for (i=50; i < 100; i++)
							{
								BEEP(10, i);
							}

						for (x = 10; x < 23; x ++)
						{
							value = 352 + x;   /* 11 * 32 + x */

							if (playfield[value] == 0)
							{
								sp_PrintAtInv(12, x,  level_colour, 'a' + rand() % 4);	
							}
							else if (playfield[value] == 1)
							{
								sp_PrintAtInv(12, x,  INK_GREEN | BRIGHT, 'e');	
							}
							else if (playfield[value] == 2)
							{
								sp_PrintAtInv(12, x,  INK_MAGENTA | BRIGHT, 'f');	
							}
							else if (playfield[value] == 3)
							{
								sp_PrintAtInv(12, x,  level_colour, 'a' + rand() % 4);	
							}
						}
					}
				}

				/* Show status bars */

				if (found)
				{
					if ((score & 31) == 1)
					{
						en ++;
						score ++;

						for (i = 10; i < 20; i++)
							BEEP (5, i);
					}

					status [16] = '0' + en / 10;
					status [17] = '0' + en % 10;
					status [35] = '0' + (num_amigos - am) / 10;
					status [36] = '0' + (num_amigos - am) % 10;
					sp_PrintString(&ps, status);
				}

				if (counter_time == 0)
				{
					status [40] = '0' + (time_left / 60) / 10;
					status [41] = '0' + (time_left / 60) % 10;
					status [43] = '0' + (time_left % 60) / 10;
					status [44] = '0' + (time_left % 60) % 10;
					sp_PrintString(&ps, status);
				}

				/* Exit conditions */

				if (en <= 0)
				{
					flag1 = 1;
					flag2 = 1;
					BEEP (5, 0);
				}

				if (sp_KeyPressed (reset))
				{
					flag1 = 1;
					flag2 = 2;
					BEEP (200, 20);
				}

				if (am == num_amigos)
				{
					flag2 = 1;
					BEEP (5, 10);
				}

				/*
				if (sp_KeyPressed (key_cheat))
				{
					flag2 = 1;
				}
				*/

			}

			// Post level code:

			/* Delete moggy */

			sp_MoveSprAbs(sp_moggy0, spritesClip, 0, 24, 32, 0, 0);
			sp_MoveSprAbs(sp_moggy1, spritesClip, 0, 24, 32, 0, 0);
			sp_MoveSprAbs(sp_moggy2, spritesClip, 0, 24, 32, 0, 0);
			sp_MoveSprAbs(sp_moggy3, spritesClip, 0, 24, 32, 0, 0);
			sp_MoveSprAbs(sp_moggy4, spritesClip, 0, 24, 32, 0, 0);					
			
			if (actrano)
			{
				sp_MoveSprAbs(sp_rano, spritesClip, 0, 24, 32, 0, 0);
			}
			
			level++;

			if (level == 25)
				break;
		}

		if (flag1)
		{
			box (5, 9, 26, 13);
			sp_PrintString(&ps, msg_gameover);
			sp_UpdateNow();
			
			sp_WaitForNoKey ();

			/* Play one of Beyker's tunes! */

			#asm
				call AD_M_GOVER
			#endasm

			sp_WaitForKey ();
		}
		
		if (level == 25)
		{
			/* Un bonito final */
			
			box (2, 3, 29, 19);
			sp_PrintString(&ps, msg_final);
			sp_PrintString(&ps, msg_theend);
			sp_UpdateNow();

			for (i = 0; i < 20; i++)
				BEEP (400, i);
			
			while (!sp_KeyPressed (key_enter) && !sp_KeyPressed (key_space));
		}
	}

}

/* (C) 2005 by Na Than Assh Antti - WOPR2K */
